unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  windows, ShellAPI, LCLIntf, LCLType, LMessages, Classes, SysUtils, FileUtil,
  Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    ImageList1: TImageList;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton10: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    procedure Button1Click(Sender: TObject);
    procedure FormDropFiles(Sender: TObject; const FileNames: array of String);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1;
  Image1:TImage;

implementation

{$R *.lfm}

{ TForm1 }

function GetShellIcon(const Name:String; const Large, Open:Boolean):HIcon;
   var FileInfo:TSHFileInfo;
       Flags:Integer;
begin
   ZeroMemory(@FileInfo, SizeOf(FileInfo));
   Flags:=SHGFI_ICON;
   If Open then Flags:=Flags or SHGFI_OPENICON;
   If Large then Flags:=Flags or SHGFI_LARGEICON else
      Flags:=Flags or SHGFI_SMALLICON;

   SHGetFileInfo(PChar(Name), 0, FileInfo, SizeOf(FileInfo), Flags);
   Result:=FileInfo.hIcon;
end;

procedure TForm1.FormDropFiles(Sender: TObject; const FileNames: array of String
  );
var
  i:integer;
begin
  for i := 0 to high(FileNames) do
      begin
        if Image1 <> nil then Image1.Free;
        Image1 := TImage.Create(Form1);
        Image1.Parent := Form1;
        Image1.Left:=100;
        Image1.Top:=100;
        Image1.Picture.Icon.Handle := GetShellIcon(FileNames[i],true, true) ;
        ImageList1.Add(Image1.Picture.Bitmap,nil);
      end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ImageList1.Clear;
end;

end.

